// Setup program for SEARCHCD

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "searchcd.h"

struct CONTROL *control;

char *memstr(char *buffer, char *string, unsigned count) {
    char *pos;

    do {
        pos=memchr(buffer,*string,count);
        if (pos) {
            if (memcmp(pos,string,strlen(string)+1)==0)
                 return pos;
        } else
            return NULL;
        buffer++;
        count--;
    } while (count>strlen(string));
    return NULL;
}

void main() {
    FILE *SEARCHCD;
    unsigned long filesize;
    char *entire;
    char *pos;
    char ch;
    char drive[100];

    SEARCHCD=fopen("SEARCHCD.EXE","r+b");
    if (!SEARCHCD) {
        printf("SEARCHCD.EXE must be in the current directory in order to\n");
        printf("configure it.\n");
        exit(1);
    }
    fseek(SEARCHCD,0,SEEK_END);
    fgetpos(SEARCHCD,&filesize);
    fseek(SEARCHCD,0,SEEK_SET);

    entire=malloc((unsigned)filesize);
    fread(entire,1,(unsigned)filesize,SEARCHCD);

    printf("Welcome to SEARCHCD setup utility.\n");
    printf("One moment please, while I search for the header ...\n");

    pos=memstr(entire,CONTROL.IDENTIFIER,(unsigned)filesize);
    if (pos==NULL) {
        printf("SETUP is unable to work with this version of SEARCHCD.EXE.\n");
        printf("Perhaps you are using the wrong version.\n");
        exit(1);
    }
    control=(struct CONTROL *)pos;


    printf("\nSEARCHCD is configured for drive %s\n",
         control->DRIVE);
    printf("Would you like to change this setting (y/n)? ");
    ch=toupper(getche());
    if (ch=='Y') {
        do {
             printf("\nPlease enter new drive letter (I.e., C:)  ");
             gets(drive);
             drive[0]=toupper(drive[0]);
             if (drive[0]<'A' || drive[0]>'Z' ||
                 (drive[1]!=':' && drive[1]!=0)) {
                     printf("Invalid drive specifier.\n");
                     continue;
              }
        } while (0);
        *control->DRIVE=drive[0];
    }

    fseek(SEARCHCD,0,SEEK_SET);
    fwrite(entire,1,(unsigned)filesize,SEARCHCD);
    fclose(SEARCHCD);

    printf("\nSetup finished successfully.\n");
}
